/*
 *  ntdsbmsg.h  NT Directory Service backup error codes
 *
 * =========================================================================
 *
 *                          Open Watcom Project
 *
 * Copyright (c) 2004-2010 The Open Watcom Contributors. All Rights Reserved.
 *
 *    This file is automatically generated. Do not edit directly.
 *
 * =========================================================================
 */

#ifndef _NTDSBMSG_
#define _NTDSBMSG_

#ifndef _ENABLE_AUTODEPEND
 #pragma read_only_file;
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Facility codes */
#define FACILITY_SYSTEM 0x000
#define FACILITY_NTDSB  0x800
#define FACILITY_BACKUP 0x7FF

/* Severity codes */
#define STATUS_SEVERITY_WARNING         0x2
#define STATUS_SEVERITY_SUCCESS         0x0
#define STATUS_SEVERITY_INFORMATIONAL   0x1
#define STATUS_SEVERITY_ERROR           0x3

/* Error codes */
#define hrNone                              0x00000000L
#define hrNyi                               0xC0000001L
#define hrInvalidParam                      0xC7FF0001L
#define hrError                             0xC7FF0002L
#define hrInvalidHandle                     0xC7FF0003L
#define hrRestoreInProgress                 0xC7FF0004L
#define hrAlreadyOpen                       0xC7FF0005L
#define hrInvalidRecips                     0xC7FF0006L
#define hrCouldNotConnect                   0xC7FF0007L
#define hrRestoreMapExists                  0xC7FF0008L
#define hrIncrementalBackupDisabled         0xC7FF0009L
#define hrLogFileNotFound                   0xC7FF000AL
#define hrCircularLogging                   0xC7FF000BL
#define hrNoFullRestore                     0xC7FF000CL
#define hrCommunicationError                0xC7FF000DL
#define hrFullBackupNotToken                0xC7FF000EL
#define hrMissingExpiryToken                0xC7FF000FL
#define hrUnknownExpiryTokenFormat          0xC7FF0010L
#define hrContentsExpired                   0xC7FF0011L
#define hrAlreadyListening                  RPC_S_ALREADY_LISTENING
#define hrFileClose                         0xC8000066L
#define hrOutOfThreads                      0xC8000067L
#define hrTooManyIO                         0xC8000069L
#define hrBFNotSynchronous                  0xC80000C8L
#define hrBFPageNotFound                    0xC80000C9L
#define hrBFInUse                           0xC80000CAL
#define hrPMRecDeleted                      0xC800012EL
#define hrRemainingVersions                 0x88000141L
#define hrFLDKeyTooBig                      0x88000190L
#define hrFLDTooManySegments                0xC8000191L
#define hrFLDNullKey                        0x88000192L
#define hrLogFileCorrupt                    0xC80001F5L
#define hrNoBackupDirectory                 0xC80001F7L
#define hrBackupDirectoryNotEmpty           0xC80001F8L
#define hrBackupInProgress                  0xC80001F9L
#define hrMissingPreviousLogFile            0xC80001FDL
#define hrLogWriteFail                      0xC80001FEL
#define hrBadLogVersion                     0xC8000202L
#define hrInvalidLogSequence                0xC8000203L
#define hrLoggingDisabled                   0xC8000204L
#define hrLogBufferTooSmall                 0xC8000205L
#define hrLogSequenceEnd                    0xC8000207L
#define hrNoBackup                          0xC8000208L
#define hrInvalidBackupSequence             0xC8000209L
#define hrBackupNotAllowedYet               0xC800020BL
#define hrDeleteBackupFileFail              0xC800020CL
#define hrMakeBackupDirectoryFail           0xC800020DL
#define hrInvalidBackup                     0xC800020EL
#define hrRecoveredWithErrors               0xC800020FL
#define hrMissingLogFile                    0xC8000210L
#define hrLogDiskFull                       0xC8000211L
#define hrBadLogSignature                   0xC8000212L
#define hrBadDbSignature                    0xC8000213L
#define hrBadCheckpointSignature            0xC8000214L
#define hrCheckpointCorrupt                 0xC8000215L
#define hrDatabaseInconsistent              0xC8000226L
#define hrConsistentTimeMismatch            0xC8000227L
#define hrPatchFileMismatch                 0xC8000228L
#define hrRestoreLogTooLow                  0xC8000229L
#define hrRestoreLogTooHigh                 0xC800022AL
#define hrGivenLogFileHasBadSignature       0xC800022BL
#define hrGivenLogFileIsNotContiguous       0xC800022CL
#define hrMissingRestoreLogFiles            0xC800022DL
#define hrExistingLogFileHasBadSignature    0x8800022EL
#define hrExistingLogFileIsNotContiguous    0x8800022FL
#define hrMissingFullBackup                 0xC8000230L
#define hrBadBackupDatabaseSize             0xC8000231L
#define hrTermInProgress                    0xC80003E8L
#define hrFeatureNotAvailable               0xC80003E9L
#define hrInvalidName                       0xC80003EAL
#define hrInvalidParameter                  0xC80003EBL
#define hrColumnNull                        0x880003ECL
#define hrBufferTruncated                   0x880003EEL
#define hrDatabaseAttached                  0x880003EFL
#define hrInvalidDatabaseId                 0xC80003F2L
#define hrOutOfMemory                       0xC80003F3L
#define hrOutOfDatabaseSpace                0xC80003F4L
#define hrOutOfCursors                      0xC80003F5L
#define hrOutOfBuffers                      0xC80003F6L
#define hrTooManyIndexes                    0xC80003F7L
#define hrTooManyKeys                       0xC80003F8L
#define hrRecordDeleted                     0xC80003F9L
#define hrReadVerifyFailure                 0xC80003FAL
#define hrOutOfFileHandles                  0xC80003FCL
#define hrDiskIO                            0xC80003FEL
#define hrInvalidPath                       0xC80003FFL
#define hrRecordTooBig                      0xC8000402L
#define hrTooManyOpenDatabases              0xC8000403L
#define hrInvalidDatabase                   0xC8000404L
#define hrNotInitialized                    0xC8000405L
#define hrAlreadyInitialized                0xC8000406L
#define hrFileAccessDenied                  0xC8000408L
#define hrBufferTooSmall                    0xC800040EL
#define hrSeekNotEqual                      0xC800040FL
#define hrTooManyColumns                    0xC8000410L
#define hrContainerNotEmpty                 0xC8000413L
#define hrInvalidFilename                   0xC8000414L
#define hrInvalidBookmark                   0xC8000415L
#define hrColumnInUse                       0xC8000416L
#define hrInvalidBufferSize                 0xC8000417L
#define hrColumnNotUpdatable                0xC8000418L
#define hrIndexInUse                        0xC800041BL
#define hrNullKeyDisallowed                 0xC800041DL
#define hrNotInTransaction                  0xC800041EL
#define hrNoIdleActivity                    0x88000422L
#define hrTooManyActiveUsers                0xC8000423L
#define hrInvalidCountry                    0xC8000425L
#define hrInvalidLanguageId                 0xC8000426L
#define hrInvalidCodePage                   0xC8000427L
#define hrNoWriteLock                       0x8800042BL
#define hrColumnSetNull                     0x8800042CL
#define hrVersionStoreOutOfMemory           0xC800042DL
#define hrCurrencyStackOutOfMemory          0xC800042EL
#define hrOutOfSessions                     0xC800044DL
#define hrWriteConflict                     0xC800044EL
#define hrTransTooDeep                      0xC800044FL
#define hrInvalidSesid                      0xC8000450L
#define hrSessionWriteConflict              0xC8000453L
#define hrInTransaction                     0xC8000454L
#define hrDatabaseDuplicate                 0xC80004B1L
#define hrDatabaseInUse                     0xC80004B2L
#define hrDatabaseNotFound                  0xC80004B3L
#define hrDatabaseInvalidName               0xC80004B4L
#define hrDatabaseInvalidPages              0xC80004B5L
#define hrDatabaseCorrupted                 0xC80004B6L
#define hrDatabaseLocked                    0xC80004B7L
#define hrTableEmpty                        0x88000515L
#define hrTableLocked                       0xC8000516L
#define hrTableDuplicate                    0xC8000517L
#define hrTableInUse                        0xC8000518L
#define hrObjectNotFound                    0xC8000519L
#define hrCannotRename                      0xC800051AL
#define hrDensityInvalid                    0xC800051BL
#define hrTableNotEmpty                     0xC800051CL
#define hrInvalidTableId                    0xC800051EL
#define hrTooManyOpenTables                 0xC800051FL
#define hrIllegalOperation                  0xC8000520L
#define hrObjectDuplicate                   0xC8000522L
#define hrInvalidObject                     0xC8000524L
#define hrIndexCantBuild                    0xC8000579L
#define hrIndexHasPrimary                   0xC800057AL
#define hrIndexDuplicate                    0xC800057BL
#define hrIndexNotFound                     0xC800057CL
#define hrIndexMustStay                     0xC800057DL
#define hrIndexInvalidDef                   0xC800057EL
#define hrIndexHasClustered                 0xC8000580L
#define hrCreateIndexFailed                 0x88000581L
#define hrTooManyOpenIndexes                0xC8000582L
#define hrColumnLong                        0xC80005DDL
#define hrColumnDoesNotFit                  0xC80005DFL
#define hrNullInvalid                       0xC80005E0L
#define hrColumnIndexed                     0xC80005E1L
#define hrColumnTooBig                      0xC80005E2L
#define hrColumnNotFound                    0xC80005E3L
#define hrColumnDuplicate                   0xC80005E4L
#define hrColumn2ndSysMaint                 0xC80005E6L
#define hrInvalidColumnType                 0xC80005E7L
#define hrColumnMaxTruncated                0xC80005E8L
#define hrColumnCannotIndex                 0xC80005E9L
#define hrTaggedNotNULL                     0xC80005EAL
#define hrNoCurrentIndex                    0xC80005EBL
#define hrKeyIsMade                         0xC80005ECL
#define hrBadColumnId                       0xC80005EDL
#define hrBadItagSequence                   0xC80005EEL
#define hrCannotBeTagged                    0xC80005F1L
#define hrRecordNotFound                    0xC8000641L
#define hrNoCurrentRecord                   0xC8000643L
#define hrRecordClusteredChanged            0xC8000644L
#define hrKeyDuplicate                      0xC8000645L
#define hrAlreadyPrepared                   0xC8000647L
#define hrKeyNotMade                        0xC8000648L
#define hrUpdateNotPrepared                 0xC8000649L
#define hrwrnDataHasChanged                 0x8800064AL
#define hrerrDataHasChanged                 0xC800064BL
#define hrKeyChanged                        0x88000652L
#define hrTooManySorts                      0xC80006A5L
#define hrInvalidOnSort                     0xC80006A6L
#define hrTempFileOpenError                 0xC800070BL
#define hrTooManyAttachedDatabases          0xC800070DL
#define hrDiskFull                          0xC8000710L
#define hrPermissionDenied                  0xC8000711L
#define hrFileNotFound                      0xC8000713L
#define hrFileOpenReadOnly                  0x88000715L
#define hrAfterInitialization               0xC800073AL
#define hrLogCorrupted                      0xC800073CL
#define hrInvalidOperation                  0xC8000772L
#define hrAccessDenied                      0xC8000773L

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _NTDSBMSG_ */
